# This module is part of a GAP package BRAID.
# It contains the initial settings of global
# variables. It also reads in all other modules.
#
# (C) K. Magaard, S. Shpectorov, 2001

path:=DirectoriesPackageLibrary("braid");

#
# Principal finite group and principal tuple

PrincipalFiniteGroup:=Group((1,2));
PrincipalTuple:=GeneratorsOfGroup(PrincipalFiniteGroup);


# Abstract generators

NumberOfGenerators_braid:=1;
OurFreeGroup:=FreeGroup(NumberOfGenerators_braid);
AbsGens:=GeneratorsOfGroup(OurFreeGroup);


# Test words

LengthOfRandomWords:=7;

NumberOfTestWords:=20;
TestWord:=[];

file:=Filename(path,"rand.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/rand.g");


#
# Tables containing an orbit
#

TupleTable:=[];
FingerprintTable:=[];

HashLength:=10000;
Hash:=[];

PrimeCode:=[];

file:=Filename(path,"table.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/table.g");


#
# Constructing the pure braid group generators
#

PQ:=[[]];

file:=Filename(path,"pq.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/pq.g");


#
# Constructing the orbit and finding the action
#

TuplePartition:=[];
BraidAction:=[[]];

file:=Filename(path,"pborbit.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/pborbit.g");


#
# Extracting permutations
#

BraidPermutation:=[[]];

file:=Filename(path,"perm.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/perm.g");

#
# Saving and restoring orbits
#

ProjectName:="JoeJob";
NumberOfOrbits:=0;

file:=Filename(path,"save.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/save.g");



#
# Managing small subgroups
#

SmallSubgroups:=[];
SizeCutoff:=0;
InitialSizeCutoff:=128;

MaximumWeight:=40;
MinimumWeight_braid:=1;
InitialWeight:=20;
BumpUp:=7;
KnockDown:=1;

TotalWeight:=0;
 
file:=Filename(path,"groups.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/groups.g");


#
# Main routine
#

InitialNumberOfRandomTuples:=20;
NumberOfRandomTuples:=InitialNumberOfRandomTuples;
RandomTuples:=[];
SuggestedTuples:=[];
InitialCutOffValue:=0;
CutOffValue:=InitialCutOffValue;

file:=Filename(path,"main.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/main.g");


#
# Computing genera
#

file:=Filename(path,"genus.g");;
Read(file);
#Read("/home/wdj/computer_algebra/gap-dev/4.0/pkg/braid/lib/genus.g");


# End


