# This module is part of a GAP package BRAID.
# It contains a function producing random words
# of a prescribed length.
#
# (C) K. Magaard, S. Shpectorov, 2001


# Function producing random words of up to a prescribed length

RandomWord:=function()
 local i,p,w;
 w:=Identity(OurFreeGroup);
 p:=RandomList([0,1]);
 for i in [1..LengthOfRandomWords+p] do
  w:=w*RandomList(AbsGens)^RandomList([-1,1]);
 od;
 if w<>One(OurFreeGroup) then
  return w;
 else
  return RandomWord();
 fi;
end;


# End

