# This module is part of a GAP package BRAID.
# It contains functions saving orbit data in 
# files and restoring it back from files
#
# (C) K. Magaard, S. Shpectorov, 2001


# Function saving a new orbit in a file

SaveOrbit:=function()
 local n,i;
 NumberOfOrbits:=NumberOfOrbits+1;
 n:=Concatenation("_",ProjectName,"/",String(NumberOfOrbits));
 AppendTo(n,"PrincipalFiniteGroup:=Group(",
            GeneratorsOfGroup(PrincipalFiniteGroup),");\n");
 AppendTo(n,"NumberOfGenerators_braid:=",NumberOfGenerators_braid,";\n");
 AppendTo(n,"OurFreeGroup:=FreeGroup(NumberOfGenerators_braid);\n");
 AppendTo(n,"AbsGens:=[];\n");
 for i in [1..Length(GeneratorsOfGroup(OurFreeGroup))] do
  AppendTo(n,"f",String(i),":=OurFreeGroup.",String(i),";\n");
  AppendTo(n,"AbsGens[",String(i),"]:=f",String(i),";\n");
 od;
 AppendTo(n,"NumberOfTestWords:=",NumberOfTestWords,";\n");
 AppendTo(n,"TestWord:=",TestWord,";\n");
 AppendTo(n,"TupleTable:=",TupleTable,";\n");
 AppendTo(n,"FingerprintTable:=",FingerprintTable,";\n");
 AppendTo(n,"HashLength:=",HashLength,";\n");
 AppendTo(n,"Hash:=",Hash,";\n");
 AppendTo(n,"PrimeCode:=",PrimeCode,";\n");
 AppendTo(n,"PQ:=",PQ,";\n");
 AppendTo(n,"BraidAction:=",BraidAction,";\n");
 AppendTo(n,"BraidPermutation:=",BraidPermutation,";\n");
end;


# Function restoring an orbit from a file

RestoreOrbit:=function(k)
 local n;
 n:=Concatenation("_",ProjectName,"/",String(k));
 Read(n);
end;


# End

